<template>
  <v-container
    fluid
    pa-0
    ma-0
  >
    <v-card
      v-if="$store.state.app.user.isAdmin"
    >
      <v-row
        no-gutters
        justify="center"
      >
        <v-col>
          <p
            class="text-center text-h4"
          >
            Existing MM Users
          </p>
        </v-col>
      </v-row>
      <v-row
        no-gutters
        justify="center"
      >
        <v-col>
          <p
            class="text-center"
          >
            These are the current users with edit and/or admin permissions.
            This means they can modify the Phasings Bids<br>
            Edit the user if you wish to change the permissions.
          </p>
        </v-col>
      </v-row>
      <v-row>
        <v-col

          class="ma-2"
        >
          <v-data-table
            :headers="headers"
            :items="mmData"
            :server-items-length="mmMeta.totalItems"
            :page.sync="mmMeta.page"
            :items-per-page="mmMeta.itemsPerPage"
            class="elevation-1"
            @page-count="pageCount = $event"
          >
            <!-- eslint-disable-next-line -->
            <template v-slot:item.mm="{ item }">
              <v-checkbox
                v-model="item.mm"
                readonly
              />
            </template>
            <!-- eslint-disable-next-line -->
            <template v-slot:item.isAdmin="{ item }">
              <v-checkbox
                v-model="item.isAdmin"
                readonly
              />
            </template>
          </v-data-table>
        </v-col>
      </v-row>
      <v-row
        no-gutters
        justify="center"
      >
        <v-col>
          <p
            class="text-center text-h4"
          >
            Find a User to Edit Permissions
          </p>
        </v-col>
      </v-row>
      <v-row>
        <v-col
          cols="4"
          class="mx-3"
        >
          <v-text-field
            v-model="userSearch"
            clearable
            label="Find a user"
          />
        </v-col>
      </v-row>
      <v-row
        v-if="showTable"
      >
        <v-col

          class="ma-2"
        >
          <v-data-table
            :headers="headers"
            :items="userData"
            :server-items-length="userMeta.totalItems"
            :page.sync="userMeta.page"
            :items-per-page="userMeta.itemsPerPage"
            class="elevation-1"
            @page-count="pageCount = $event"
          >
            <!-- eslint-disable-next-line -->
            <template v-slot:item.mm="{ item }">
              <v-checkbox
                v-model="item.mm"
                @click="makeMM(item)"
              />
            </template>
            <!-- eslint-disable-next-line -->
            <template v-slot:item.isAdmin="{ item }">
              <v-checkbox
                v-model="item.isAdmin"
                readonly
                @click="makeAdmin(item)"
              />
            </template>
          </v-data-table>
        </v-col>
      </v-row>
    </v-card>
  </v-container>
</template>

<script>
// eslint-disable-next-line
import { cloneDeep, isEqual } from 'lodash';
// eslint-disable-next-line
import { patch, post, get } from 'kyd-utils';

export default {
  name: 'Home',
  components: {
  },
  data: () => ({
    sortBy: 'username',
    sortDesc: false,
    pageCount: 0,
    itemsPerPage: 10,
    userSearch: '',
    headers: [
      {
        text: 'User Name',
        align: 'start',
        width: '20%',
        value: 'username',
      },
      {
        text: 'Name',
        align: 'start',
        width: '20%',
        value: 'name',
      },
      {
        text: 'Email',
        align: 'start',
        width: '20%',
        value: 'email',
      },
      {
        text: 'Phone',
        align: 'start',
        width: '10%',
        value: 'phone',
      },
      {
        text: 'Is MM Mbr',
        align: 'start',
        width: '5%',
        value: 'mm',
      },
      {
        text: 'Is Admin',
        align: 'start',
        width: '5%',
        value: 'isAdmin',
      },
    ],
    userData: [],
    userMeta: {
      totalItems: 0,
      itemsPerPage: 10,
      sort: [{ asc: true, key: 'name' }],
      filter: [],
      page: 1,
    },
    mmData: [],
    mmMeta: {
      totalItems: 0,
      itemsPerPage: 10,
      sort: [{ asc: true, key: 'name' }],
      filter: [],
      page: 1,
    },
    editedUserDialog: false,
    editedIndex: -1,
  }),
  computed: {
    showTable() {
      let s = false;
      const uS = cloneDeep(this.userSearch);
      if (uS !== undefined && uS !== null && uS !== '') {
        s = true;
      }
      return s;
    },
    vW: {
      get() {
        return this.$store.state.app.vWH.x * 0.85;
      },
    },
    page: {
      get() {
        const t = this.userMeta.page;
        return t;
      },
      set(v, ov) {
        if (!isEqual(v, ov)) {
          // eslint-disable-next-line
          this.userMeta.page = v;
        }
      },
    },
  },
  watch: {
    page: {
      deep: true,
      handler(nv, ov) {
        if (nv !== ov) {
          // console.log('the page has changed', nv);
          this.refreshTable();
        }
      },
    },
    userSearch: {
      handler(v) {
        if (v === undefined || v === null) {
          this.userSearch = '';
          // console.log('the page has changed', nv);
        }
        this.refreshTable();
      },
      immediate: true,
    },
  },
  mounted() {
    this.refreshTable();
    this.refreshMMTable();
  },
  methods: {
    async refreshTable() {
      const uS = cloneDeep(this.userSearch);
      let filter = [];
      if (uS !== undefined && uS !== null && uS !== '') {
        filter = [{ key: 'searchable', like: `%${uS}%` }];
        // console.log('the filter', filter);
      }
      const payload = {
        ...this.userMeta,
        filter,
      };
      // console.log('the payload', payload);
      const response = await get('/user-data', { params: payload });
      // console.log('the resp', response);
      this.userData = response.data;
      this.userMeta = {
        ...payload,
        ...response.meta,
      };
      this.refreshMMTable();
    },
    async refreshMMTable() {
      const uS = cloneDeep(this.mmSearch);
      let filter = [{ key: 'mm', equals: true }];
      if (uS !== undefined && uS !== null && uS !== '') {
        filter = [{ key: 'mm', equals: true }, { key: 'searchable', like: `%${uS}%` }];
        // console.log('the filter', filter);
      }
      const payload = {
        ...this.mmMeta,
        filter,
      };
      // console.log('the mm payload', payload);
      const response = await get('/user-data', { params: payload });
      // console.log('the mm resp', response);
      this.mmData = response.data;
      this.mmMeta = {
        ...payload,
        ...response.meta,
      };
    },
    async makeMM(u) {
      // console.log('the user', u);
      const payload = {
        mm: u.mm,
      };
      const filter = {
        filter: [{ key: 'id', equals: u.id }],
      };
      const params = { params: filter };
      // console.log('patch', payload, params);
      await patch(
        '/user-data-patch',
        payload,
        params,
      );
      this.userSearch = '';
      this.refreshTable();
      this.refreshMMTable();
    },
    async makeAdmin(u) {
      // console.log('the usr ', u);
      const isAdm = this.$store.state.app.user.isAdmin;
      if (isAdm === true) {
      // console.log('the user', u);
        const newV = !u.isAdmin;
        const payload = {
          isAdmin: newV,
        };
        const filter = {
          filter: [{ key: 'id', equals: u.id }],
        };
        const params = { params: filter };
        // console.log('patch', payload, params);
        await patch(
          '/user-data-patch',
          payload,
          params,
        );
        this.userSearch = '';
        this.refreshTable();
        this.refreshMMTable();
      }
    },
  },
};

</script>
